
//  Copyright <2021> <Hans de Nivelle>
//
//  This software is released with the 3-clause BSD license, which 
//  is given below: 
// 
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions are met:

//  Redistributions of source code must retain the above copyright notice, 
//  this list of conditions and the following disclaimer:

//  Redistributions in binary form must reproduce the above copyright notice, 
//  this list of conditions and the following disclaimer in the documentation 
//  and/or other materials provided with the distribution.
//  Neither the name of the copyright holder nor the names of its contributors 
//  may be used to endorse or promote products derived from this software 
//  without specific prior written permission.

//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
//  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
//  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
//  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
//  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.



// code written by Hans de Nivelle, September 2021.

#include "function.h"

namespace prolog
{

#if 0
   bool funcpred::isdefined( const std::string& stringrepr,
		             unsigned int arity )
   {
      std::map< std::string, std::list< unsigned int > > :: iterator 
            i = lookuptable. find( stringrepr );

      if( i == lookuptable. end( ))
         return false;

      for( std::list< unsigned > :: const_iterator 
              j = ( i -> second ). begin( );
	      j != ( i -> second ). end( );
	      ++ j )
      {
         if( properties [ *j ]. arity == arity )
            return true;
      }
      return false;
   }


   funcpred::funcpred( const std::string& stringrepr,
	               unsigned int arity ) 
   {
      std::map < std::string, std::list< unsigned int > > :: iterator 
            i = lookuptable. find( stringrepr ); 

      if( i == lookuptable. end( ))
      {
         std::pair< 
	      std::map< std::string, std::list< unsigned int > > :: iterator, 
	      bool > 
         ins =
	    lookuptable. insert( 
               std::pair< std::string, std::list< unsigned int > > (
                     stringrepr, std::list< unsigned int > ( )));
         ASSERT( ins. second ); 
         i = ins. first; 
      }

      for( std::list< unsigned int > :: const_iterator
              j = ( i -> second ). begin( );
	      j != ( i -> second ). end( );
	      ++ j )
      {
         if( properties [ *j ]. arity == arity )
         {
            repr = *j;
	    return;
         }
      }

      // We need to create a new entry in the tables.

      repr = properties. size( );

      properties. push_back( prop( stringrepr, arity ));
      i -> second. push_back( repr );
   }


   void funcpred::printtable( std::ostream& stream ) 
   {
      stream << "Table of Function or Predicate Names:\n";
      stream << "=====================================\n\n";
      for( unsigned int i = 0; i < properties. size( ); ++ i )
      {
         stream << properties [i]. stringrepr;
         stream << " / ";
         stream << properties [i]. arity;
         stream << "\n";
      }
      stream << "\n\n";

#if 1
      for( std::map< std::string, std::list< unsigned int > > :: const_iterator 
	      i = lookuptable. begin( );
              i != lookuptable. end( );
	      ++ i )
      {
         stream << "( " << i -> first << ", " ;

         stream << "[ ";
         for( std::list< unsigned int > :: const_iterator 
                 j = ( i -> second ). begin( );
	         j != ( i -> second ). end( );
	         ++ j )
         {
            if( j != ( i -> second ). begin( ))
               stream << ", ";
	    stream << *j;
         }
         stream << " ] ) ";
      }
      stream << "\n\n"; 
#endif
   }
#endif 
}




