
//  Copyright <2021> <Hans de Nivelle>
//
//  This software is released with the 3-clause BSD license, which 
//  is given below: 
// 
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions are met:

//  Redistributions of source code must retain the above copyright notice, 
//  this list of conditions and the following disclaimer:

//  Redistributions in binary form must reproduce the above copyright notice, 
//  this list of conditions and the following disclaimer in the documentation 
//  and/or other materials provided with the distribution.
//  Neither the name of the copyright holder nor the names of its contributors 
//  may be used to endorse or promote products derived from this software 
//  without specific prior written permission.

//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
//  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
//  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
//  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
//  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.



// Written by Hans de Nivelle, December 2020, part of the Easy project.

#ifndef UTIL_HASHBUILDER_
#define UTIL_HASHBUILDER_   1

#include <iostream>

namespace util
{

   struct hashbuilder
   {
      size_t val;

      hashbuilder( ) 
         : val(0)
      { }

      hashbuilder( size_t s )
         : val(s)
      { }

      void clear( ) 
         { val = 0; }
   };


   inline hashbuilder& operator << ( hashbuilder& b, int i )
   { 
      b.val ^= b.val << 13;
      b.val ^= b.val >> 7;
      b.val ^= b.val << 17; 
      b.val ^= i;
      return b; 
   }


   inline hashbuilder& operator << ( hashbuilder& b, size_t s )
   { 
      b.val ^= b.val << 13;
      b.val ^= b.val >> 7;
      b.val ^= b.val << 17;  
      b.val ^= s;
      return b;  
   }

   inline hashbuilder& operator << ( hashbuilder& b, const char* p )
   {
      while(*p)
         b << * ( p ++ );
      return b; 
   }   

   inline std::ostream& operator << ( std::ostream& out, const hashbuilder& b )
      { return out << "hashbuilder( " << b. val << " )"; } 

}

#endif


